/***************************************************************************
                          bookmarkcombobox.cpp  -  description
                             -------------------
    begin                : Fri Dec 14 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#include "bookmarkcombobox.h"
#include <qlineedit.h>

bookmarkComboBox::bookmarkComboBox(const char *name, QWidget *parent)
  : QComboBox(true,parent,name)
{
  n = name;
  setFont(QFont(parent->font().family(),11));
  setDuplicatesEnabled(false);
//  setAutoCompletion(true);  // funktioniert nicht einwandfrei fr unser Thema!!
  setInsertionPolicy(AtTop);
//  setMaxCount(10);

  // Combobox, die die Items in die Config speichert, und bei Neustart wieder einliest.
  // Desweiteren Autovervollstndigung
  QSettings settings;
  QString tree = QString("/KCommander/Bookmarks/") + name + "/";
  QString bm;
  int i=0;
  bool ready=false;
  do
  {
    bm.sprintf("Entry%2.2d",i);
    bm = settings.readEntry(tree + bm,"");
    if(bm == "")
      ready = true;
    else
      QComboBox::insertItem(bm,i++);
  } while(!ready);
  setEditText("");
  show();
  connect(this,SIGNAL(activated(int)),SLOT(activated(int)));
  connect(this,SIGNAL(textChanged(const QString &)),SLOT(textChanged(const QString &)));
}
bookmarkComboBox::~bookmarkComboBox(){}

void bookmarkComboBox::textChanged(const QString &s)
{
}
void bookmarkComboBox::activated(int /*index*/)
{
  QSettings settings;
  QString tree = QString("/KCommander/Bookmarks/") + n + "/";
  QString bm;
  for(int i=0;i<count();i++)
  {
    bm.sprintf("Entry%2.2d",i);
    settings.writeEntry(tree + bm,text(i));
  }
}
void bookmarkComboBox::keyPressEvent(QKeyEvent *e)
{
  // ComboBox DARF die Cursor hoch&runter NICHT benutzen
  if(e->key() == 4115 || e->key() == 4117)
  {
    e->accept();
    emit cursorRequested(e);
  }
  else
    e->ignore();
}
void bookmarkComboBox::keyReleaseEvent(QKeyEvent *e)
{
  // Hier dem Listview beibringen, dass er den Balken bewegt!
  if(e->key() == 4115)
  {
    e->accept();
    return;
  }
  if(e->key() == 4117)
  {
    e->accept();
    return;
  }
  // INFO
  // wird nur aufgerufen, wenn Combo focussed!!
  if(e->key() == Key_Enter || e->key() == Key_Return)
  {
    e->accept();
    if(e->state() == Qt::AltButton )
    {
        emit itemRequested();
        return;
    }
    // Arno CommandParser
    // sinniger Weise weitergereicht nach    // hehe alles klaro , isch krass nisch durchgesehe
    //   kcommander3view()
    emit doCommand(lineEdit()->text());
    setEditText("");
    // this is only for main window, to focus the listview
    emit commandBoxReady();
  }
  else
    e->ignore();
}

void  bookmarkComboBox::insertItem(QString item, int index)
{
  QSettings settings;
  QString tree = QString("/KCommander/Bookmarks/") + n + "/";
  QString bm;
    bm.sprintf("Entry%2.2d",count());
    settings.writeEntry(tree + bm,item);

  QComboBox::insertItem(item,index);
}

void  bookmarkComboBox::reRead()
{
  clear();
  QSettings settings;
  QString tree = QString("/KCommander/Bookmarks/") + name() + "/";
  QString bm;
  int i=0;
  bool ready=false;
  do
  {
    bm.sprintf("Entry%2.2d",i);
    bm = settings.readEntry(tree + bm,"");
    if(bm == "")
      ready = true;
    else
      QComboBox::insertItem(bm,i++);
  } while(!ready);
  setEditText("");
}
