/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/

class Preview : public QLabel, public QFilePreview
{
  public:
    Preview( QWidget *parent=0 ) : QLabel( parent ) {}
      void previewUrl( const QUrl &u )
      {
        QString path = u.path();
        QPixmap pix( path );
        if ( pix.isNull() )
          setText( "This is not a pixmap" );
        else
          setPixmap( pix );
      }
};

void dlgOptions::changeLeftColor()
{
  QColor nc = QColorDialog::getColor();
  // If the user dont pressed 'CANCEL' then
  if(nc.isValid())
  {
     makeLeftColor->setPaletteBackgroundColor(nc);
     QSettings settings;
     settings.writeEntry(QString("/Kcommander/Colors/ListView1Background/"), nc.name());
     emit leftColorChanged();
  }  
}

void dlgOptions::changeRightColor()
{
  QColor nc = QColorDialog::getColor();
  // If the user dont pressed 'CANCEL' then
  if(nc.isValid())
  {
    makeRightColor->setPaletteBackgroundColor(nc);
    QSettings settings;
    settings.writeEntry(QString("/Kcommander/Colors/ListView2Background/"), nc.name());
    emit rightColorChanged();
  }  
}

void dlgOptions::okPressed()
{
  QSettings settings;
  settings.writeEntry("/KCommander/Mail/Mailserver/", generalMailServer->text());
  settings.writeEntry("/KCommander/Mail/Mailserver_In/", generalMailServer_In->text());
  settings.writeEntry("/KCommander/Mail/Mailusername/", generalMailUsername->text());
  settings.writeEntry("/KCommander/Mail/MailPasswd",generalMailPasswd->text());
  settings.writeEntry("/KCommander/Mail/PopLoginFirst",checkPopLogin->isChecked());
  if(checkNoPixmap->isChecked())
    bgPixmapPath = "";
  settings.writeEntry("/KCommander/Style/BG_PixmapPath",bgPixmapPath);

  settings.writeEntry("/KCommander/Style/MenuFont",menuFont);
  settings.writeEntry("/KCommander/Style/ViewFont",viewFont);
  settings.writeEntry("/KCommander/Show Tooltips",generalSTT->isChecked());
  accept();
}

void dlgOptions::slotAskWhenQuit(int answer)
{
  QSettings settings;
  if(answer != 2)
	  settings.writeEntry( "/KCommander/Ask Quit", "No");
  else
	  settings.writeEntry( "/KCommander/Ask Quit", "Yes");
}

void dlgOptions::slotSaveLastPaths(int)
{
  QSettings settings;
  settings.writeEntry("/KCommander/Save Visited",generalSLP->isChecked());
}

void dlgOptions::slotShowHidden(int)
{
  QSettings settings;
  settings.writeEntry("/KCommander/Show Hidden",generalSHF->isChecked());
}

void dlgOptions::slotIconViewSettingsChanged(int)
{
  if(! configIconViewChanged)
    return;
  QSettings settings;
  settings.writeEntry("/KCommander/IconView/gridSize",gridSizeSpin->value());
  settings.writeEntry("/KCommander/IconView/ArrangeTB", checkArrangeTB->isChecked());
  settings.writeEntry("/KCommander/IconView/ArrangeLR", checkArrangeLR->isChecked());
  settings.writeEntry("/KCommander/IconView/underIcon",  checkUnderIcon->isChecked());
  settings.writeEntry("/KCommander/IconView/leftSide",     checkLeftSide->isChecked());
  settings.writeEntry("/KCommander/IconView/italic", checkItalicSymlinkIV->isChecked());
  settings.writeEntry("/KCommander/IconView/bold", checkBoldSymlinksIV->isChecked());
}

void dlgOptions::slotListViewSettingsChanged(int)
{
  if(!configListViewChanged)
    return;
  QSettings settings;
  settings.writeEntry("/KCommander/ListView/recolor", checkColorColumns->isChecked());
  settings.writeEntry("/KCommander/ListView/italic",checkItalicSymlinksLV->isChecked());
  settings.writeEntry("/KCommander/ListView/bold",checkBoldSymlinksLV->isChecked());
}

void dlgOptions::setData()
{
  configIconViewChanged = false;
  configListViewChanged = false;
  bgPixmapPath = "";
  viewFont ="";
  menuFont="";
  QSettings settings;

  // General Settings
  QString ask = settings.readEntry("/KCommander/Ask Quit","Yes");
  if(ask == "Yes")
    generalAWQ->setChecked(true);
  else	
    generalAWQ->setChecked(false);
  bool ask_bool;
  ask_bool = settings.readBoolEntry("/KCommander/Save Splittersize",true);
  if(ask_bool)
    generalSSS->setChecked(true);
  else	
    generalSSS->setChecked(false);
  ask_bool = settings.readBoolEntry("/KCommander/Save Visited",true);
  if(ask_bool)
    generalSLP->setChecked(true);
  else	
    generalSLP->setChecked(false);
  ask_bool = settings.readBoolEntry("/KCommander/Show Hidden",true);
  if(ask_bool)
    generalSHF->setChecked(true);
  else	
    generalSHF->setChecked(false);
  ask_bool = settings.readBoolEntry("/KCommander/Show Tooltips",true);
  generalSTT->setChecked(ask_bool);
//   ask = settings.readEntry("/KCommander/Mail/Mailpwd","none");    generalMailPWD->setText(ask);

 // Mail Settings
  ask = settings.readEntry("/KCommander/Mail/Mailserver","none");
  generalMailServer->setText(ask);
  ask = settings.readEntry("/KCommander/Mail/Mailserver_In","none");
  generalMailServer_In->setText(ask);
  ask = settings.readEntry("/KCommander/Mail/Mailusername","none");
  generalMailUsername->setText(ask);
  ask = settings.readEntry("/KCommander/Mail/MailPasswd","none");
  generalMailPasswd->setText(ask);
  ask_bool = settings.readBoolEntry("/KCommander/Mail/PopLoginFirst",true);
  if(ask_bool)
    checkPopLogin->setChecked(true);

  // Color Settings
  QColor bg;
  bg = settings.readEntry(QString("/KCommander/Colors/ListView1Background/"),"#c0c0c0");
  makeLeftColor->setPaletteBackgroundColor(bg);
  bg = settings.readEntry(QString("/KCommander/Colors/ListView2Background/"),"#c0c0c0");
  makeRightColor->setPaletteBackgroundColor(bg);
  checkLeftColor->setChecked(true);

  // Style Settings
  ask = settings.readEntry("/KCommander/Style/BG_PixmapPath","");
  bgPixmapButton->setPixmap(QPixmap(ask));
  bgPixmapPath = ask;
  if(ask == "")
    checkNoPixmap->setChecked(true);
  ask = settings.readEntry("/KCommander/Style/MenuFont","no");
  editFont_Menu->setText(ask);
  menuFont = ask;
  ask = settings.readEntry("/KCommander/Style/ViewFont","no");
  editFont_Views->setText(ask);
  viewFont = ask;
  bg = settings.readEntry(QString("/KCommander/Style/MenuFontColor/"),"#c0c0c0");
  btMenuFontColor->setPaletteForegroundColor(bg);
  bg = settings.readEntry(QString("/KCommander/Style/ViewFontColor/"),"#c0c0c0");
  btViewFontColor->setPaletteForegroundColor(bg);

  // ListView Settings
  ask_bool = settings.readBoolEntry("/KCommander/ListView/recolor",true);
  if(ask_bool)
    checkColorColumns->setChecked(true);
  else	
    checkColorColumns->setChecked(false);
  ask_bool = settings.readBoolEntry("/KCommander/ListView/italic",true);
  if(ask_bool)
    checkItalicSymlinksLV->setChecked(true);
  else	
    checkItalicSymlinksLV->setChecked(false);
  ask_bool = settings.readBoolEntry("/KCommander/ListView/bold",true);
  if(ask_bool)
    checkBoldSymlinksLV->setChecked(true);
  else	
    checkBoldSymlinksLV->setChecked(false);

 // IconView Settings
  int ask_num;
  ask_num = settings.readNumEntry("/KCommander/IconView/gridSize",155);
  gridSizeSpin->setValue(ask_num);
  ask_bool = settings.readBoolEntry("/KCommander/IconView/ArrangeTB",true);
  checkArrangeTB->setChecked(ask_bool);
  ask_bool = settings.readBoolEntry("/KCommander/IconView/ArrangeLR",true);
  checkArrangeLR->setChecked(ask_bool);
  ask_bool = settings.readBoolEntry("/KCommander/IconView/underIcon",true);
  checkUnderIcon->setChecked(ask_bool);
  ask_bool = settings.readBoolEntry("/KCommander/IconView/leftSide",true);
  checkLeftSide->setChecked(ask_bool);
  ask_bool = settings.readBoolEntry("/KCommander/IconView/italic",true);
  checkItalicSymlinkIV->setChecked(ask_bool);
  ask_bool = settings.readBoolEntry("/KCommander/IconView/bold",true);
  checkBoldSymlinksIV->setChecked(ask_bool);
  configIconViewChanged = true;
  configListViewChanged = true;
}


void dlgOptions::slotSaveSplitterSize( int )
{
  QSettings settings;
  settings.writeEntry("/KCommander/Save Splittersize",generalSSS->isChecked());
}

void dlgOptions::slotBlueChanged( int num)
{
  QString Color;
  Color.sprintf("%d",num);
  lb_blue->setText(Color);
  if(checkLeftColor->isChecked())
  {
     makeLeftColor->setPaletteBackgroundColor(QColor(sliderRed->value(),sliderGreen->value(),sliderBlue->value()));
  }
  else
  {
     makeRightColor->setPaletteBackgroundColor(QColor(sliderRed->value(),sliderGreen->value(),sliderBlue->value()));
  }
}

void dlgOptions::slotGreenChanged( int num )
{
  QString Color;
  Color.sprintf("%d",num);
  lb_green->setText(Color);
  if(checkLeftColor->isChecked())
  {
    makeLeftColor->setPaletteBackgroundColor(QColor(sliderRed->value(),sliderGreen->value(),sliderBlue->value()));
  }
  else
  {
    makeRightColor->setPaletteBackgroundColor(QColor(sliderRed->value(),sliderGreen->value(),sliderBlue->value()));
  }
}

void dlgOptions::slotRedChanged( int num)
{
  QString Color;
  Color.sprintf("%d",num);
  lb_red->setText(Color);
  if(checkLeftColor->isChecked())
  {
    makeLeftColor->setPaletteBackgroundColor(QColor(sliderRed->value(),sliderGreen->value(),sliderBlue->value()));
  }
  else
  {
    makeRightColor->setPaletteBackgroundColor(QColor(sliderRed->value(),sliderGreen->value(),sliderBlue->value()));
  }
}

void dlgOptions::slotCheckRightColorClicked( int )
{
   if(! checkRightColor->isChecked())
    return;
   QColor tmp(makeRightColor->paletteBackgroundColor());
   sliderRed->setValue(tmp.red());
   sliderGreen->setValue(tmp.green());
   sliderBlue->setValue(tmp.blue());
}

void dlgOptions::slotCheckLeftColorClicked( int )
{
   if(! checkLeftColor->isChecked())
    return;
   QColor tmp(makeLeftColor->paletteBackgroundColor());
   sliderRed->setValue(tmp.red());
   sliderGreen->setValue(tmp.green());
   sliderBlue->setValue(tmp.blue());
}

void dlgOptions::slotSliderReleased()
{
   QSettings settings;
   settings.writeEntry(QString("/Kcommander/Colors/ListView1Background/"), makeLeftColor->paletteBackgroundColor().name());
   settings.writeEntry(QString("/Kcommander/Colors/ListView2Background/"), makeRightColor->paletteBackgroundColor().name());
}

void dlgOptions::changeBgPixmap()
{
   Preview* p = new Preview;
   kcFileIconProvider *iic = new kcFileIconProvider();
   QFileDialog* fd = new QFileDialog( this,"LoadPixmap",true );
   fd->setIconProvider(iic);
   fd->setContentsPreviewEnabled( TRUE );
   fd->setContentsPreview( p, p );
   fd->setPreviewMode( QFileDialog::Contents );
   fd->setFilter( "All picture files (*.xpm *.png)" );
   connect(fd,SIGNAL(fileSelected(const QString &)),this,SLOT(setSelectedPixmap(const QString &)));
   fd->show();
}

void dlgOptions::setSelectedPixmap(const QString &file)
{
   bgPixmapPath = file;
   bgPixmapButton->setPixmap(QPixmap(file));
   checkNoPixmap->setChecked(false);
}

QString dlgOptions::selectMenuFont()
{
   bool ok;
   QFont font = QFontDialog::getFont( &ok, QFont( "Helvetica [Cronyx]", 10 ), this );
   menuFont = font.toString();
   editFont_Menu->setText(font.toString());
   return(font.toString());
}

QString dlgOptions::selectViewFont()
{
   bool ok;
   QFont font = QFontDialog::getFont( &ok, QFont( "Helvetica [Cronyx]", 10 ), this );
   viewFont = font.toString();
   editFont_Views->setText(font.toString());
   return(font.toString());
}

void dlgOptions::changeMenuFontColor()
{
  QColor nc = QColorDialog::getColor();
  // If the user dont pressed 'CANCEL' then
  if(nc.isValid())
  {
     btMenuFontColor->setPaletteForegroundColor(nc);
     QSettings settings;
     settings.writeEntry(QString("/Kcommander/Style/MenuFontColor/"), nc.name());
  }      
}
void dlgOptions::changeViewFontColor()
{
  QColor nc = QColorDialog::getColor();
  // If the user dont pressed 'CANCEL' then
  if(nc.isValid())
  {
     btViewFontColor->setPaletteForegroundColor(nc);
     QSettings settings;
     settings.writeEntry(QString("/Kcommander/Style/ViewFontColor/"), nc.name());
  }      
}

void dlgOptions::setNoPixmap(bool checked)
{
  debug("Clicked");
  if( checkNoPixmap->isChecked())
    bgPixmapButton->setBackgroundColor(white);
}
