//***************************************************************
// KTar2.h
//***************************************************************
#ifndef KTar2_H
#define KTar2_H

#include <qwidget.h>
#include <qprocess.h>
#include <qlabel.h>
#include <qdir.h>
#include <qmessagebox.h>
#include <qfile.h>
#include <qprogressbar.h>

#include "kcview.h"
#include "kciconview.h"
#include "kclistview.h"

/**
  *@author Christian Fricke & Ren Mrten
  */

class KTar2 : public QDialog  {
   Q_OBJECT
public:
	KTar2(kcView* ,const char *archivename,QWidget *parent=0, const char *name=0);
	~KTar2();
	void doIt(const char *archivename);
	QProgressBar *p1;
	QLabel		*dateiname;
	QString		SourcePath;
	QString		Packer;
	void			start();
	int				percent;
	bool			ready,ende;
  bool			nextFile;
  const char 			*temp,*arc;

private:	
  QStrList  *liste;
	kcView    *source;
	bool      deleteSymlinks;

  void      recurse(QString);
  void      getRecursiveList();

private slots:
	void			timerEvent(QTimerEvent *);
	void			slotExamine();
	void 			receivedStdout();
	void 			receivedStderr();
	void			closeEvent ( QCloseEvent *);

};

#endif


