/***************************************************************************
                          hexviewedit.cpp  -  description
                             -------------------
    begin                : Mon Jan 7 2002
    copyright            : (C) 2002 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


// Einbauen:

// F7       - Suche Text
// Shift+F7 - Suche HEX
// F3 - Weitersuchen


// Also bauen wir den Scheiss um ;o)

#define cursorw 7
#define CURSORCOLOR QColor(100,200,100)

#include "hexviewedit.h"

hexViewEdit::hexViewEdit(QString fileName, bool editflag, QWidget *parent, const char *name ) : QWidget(parent,name)
{
  bytesPerLine = 0;
  undoList = NULL;
  undos = 0L;

  TABFLAG = 0;
  scrollbar = new QScrollBar(this);
  scrollbar->setMinValue(0);
//  scrollbar->setMaxValue(0);  wird im ResizeEvent gesetzt
  scrollbar->setLineStep(1);
  scrollbar->setFocusPolicy(NoFocus);
  connect(scrollbar, SIGNAL(valueChanged(int)), SLOT(scrollbarChanged(int)));
  // OK, ich fang nochmal an....
  // zuerst einmal min und max festlegen

  setMinimumSize(540,400);
  resize(540,400);
//  setMaximumSize(600,32000);

  // merken, ob EDIT oder VIEW
  edit = editflag;
//  edit = true;

  // damit nicht zwei Blittings parallel laufen !!
  resizing = false;

  // Zwischenspeicher
  filebuffer = 0L;
  // buffersize berechnet sich aus der aktuellen fensterhhe (Zeilen * 16 Bytes)
  buffersize = 0L;
  // wo befinden wir uns im file? (seek pointer)
  filepos = 0L;
  // na was wohl ;)
  blinkflag = true;
  // wurde das erste von 2 Zeichen eingegeben, so ist digit = TRUE
  digit = false;
  // Cursorindex berechnet sich wie folgt:
  // ganz oben links das Zeichen ist = filepos
  // dann CursorX * 16 dazu (Zeilen)
  // und nun noch CursorX addieren
  cursorIndex = 0L;
  // Hintergrund weiss
  setBackgroundColor(white); // CONFIGURABLE !!
  // CursorPositionen DEFAULTS
  cursorX = cursorY = 0L;
  // Timer fr CursorBlink
  ctimer = new QTimer(this);
  connect(ctimer,SIGNAL(timeout()), SLOT(cursorTimer()));
  ctimer->start(500);
  // Double Buffering Pixmap - hier rein wird geschrieben
  // Grsse erst 1 Byte - passt sich Fenstergrsse an...
  bufferPixmap = new QPixmap(1);
  // nuja
  filename = fileName;
  // ist dies der Viewer, nur READ ffnen, beim EDIT Read/Write
  if(!edit)
  {
    file = fopen(filename,"r");
    setCaption( tr("Viewing ") + filename);
  }
  else
  {
    file = fopen(filename,"r+");  // Read/Write, falls nicht existiert, wird neu angelegt...
    setCaption( tr("Editing ") + filename);
  }

  // erfolgreich?
  if(!file)
  {
    // File ging nicht zu ffnen --> View/Edit ausblenden !!
    close();
    delete this;
    return;
  }
  // OK, file offen
  // nun Dateigrsse holen
  struct stat stat_p;
  stat (filename, &stat_p);
  filesize = stat_p.st_size;

  // Font auf FIXED setzen
  myFont = new QFont("fixed", 14,QFont::Bold);  // CONFIGURABLE !!
  // ohne diesem gibt pixelSize() -1 zurck
  myFont->setPixelSize(14);                             // Hier machst du die Ansicht breiter, probiere mal aus :)
  // feste Breite fr Font setzen
  myFont->setFixedPitch(1);
  setFont(*myFont);
  fontsize = myFont->pixelSize();
  show();
  // OK, bis hierhin alles klar, ab zum resizeEvent()
}
hexViewEdit::~hexViewEdit(){
}
void hexViewEdit::keyReleaseEvent(QKeyEvent *e)
{
  e->accept();
}
void hexViewEdit::cursorBack()
{
  // Fileanfang??
  if(cursorIndex == 0)
    return;
  if(cursorX > 0)
    moveCursor(-1,0);
  else
  {
    moveCursor(bytesPerLine-1,0);
    if(cursorY == 0)
      scroll(-1);
    else
      moveCursor(0,-1);
  }
}
void hexViewEdit::cursorToNextPos()
{
  // Fileende ??
  if((uint)cursorIndex+1 == filesize)
    return;
  // OK, Cursor kann auf jeden Fall weiter
  if(cursorX < (bytesPerLine-1))
    moveCursor(1,0);
  else
  {
    moveCursor(-cursorX,0);
    if(cursorY+1 == lines)
      scroll(1);
    else
      moveCursor(0,1);
  }
}
void hexViewEdit::moveCursor(int xoff, int yoff)
{
  ctimer->stop();
  deleteCursor();
  cursorX += xoff;
  cursorY += yoff;
  cursorIndex = filepos + (cursorY*bytesPerLine) + cursorX;
  cursorTimer();
  ctimer->start(500);
  updateInfo();
}
void hexViewEdit::scroll(int yoff) // Zeilenweise
{
  ctimer->stop();
  deleteCursor();
  filepos += (yoff * bytesPerLine);
  cursorIndex = filepos + (cursorY*bytesPerLine) + cursorX;
  // OK, jetzt ab der Stelle im File neu einlesen
  read();
  // und noch nen bischen blitten
  fillBuffer();
  paintEvent((QPaintEvent *)0L);
  cursorTimer();
  ctimer->start(500);
  updateInfo();
}
void hexViewEdit::keyPressEvent(QKeyEvent *e)
{
  // Wurde bereits ein Zeichen im Hexedit eingegeben,
  // so fragen wir die Tastatur nicht mehr ab...
  if(!digit)
  switch(e->key())
  {
    case Qt::Key_U:
    {
      if(e->state()==512) // STRG !!
      {
        undoOneItem();
        e->accept();
        return;
      }
      else
      e->ignore();
      break;
    }
    case Qt::Key_Tab:
    {
      if(TABFLAG ==0)
        TABFLAG = 1;
      else
        TABFLAG = 0;
      ctimer->stop();
      deleteCursor();
      cursorTimer();
      ctimer->start(500);
      e->accept();
      return;
      break;
    }
    case Qt::Key_Escape:
    {
      fclose(file);
      e->accept();
//      close();
      emit closeParent();
      return;
      break;
    }
    //****************************************************************
    case Qt::Key_Left:
    {
      cursorBack();
      e->accept();
      return;
      break;
    }
    //****************************************************************
    case Qt::Key_Right:
    {
      cursorToNextPos();
      e->accept();
      return;
      break;
    }
    //****************************************************************
    case Qt::Key_Up:
    {
      // Wenn wir am Anfang sind, CursorUp ignorieren
      if(!filepos && !cursorY) // Am Anfang, und Cursor OBEN?
      {
        ; // Do nothing
      }
      else
      {
        if(!cursorY) // Cursor oberste Zeile?
        {
          scroll(-1);
        }
        else
        {
          // Cursor war weiter unten
          moveCursor(0,-1);
        } // END if(!cursorY)

      } // END if(!filepos && !cursorY)
      e->accept();
      return;
      break;
    } // END Key_Up

    //****************************************************************
    case Qt::Key_Down:
    {
      // Wenn wir am Anfang sind, CursorUp ignorieren
      if((uint)cursorIndex+bytesPerLine >= filesize) // Sind wir am Ende?
      {
        ; // EOF!!
      }
      else
      {
        if(cursorY >= (lines-1)) // Cursor letzte Zeile?
        {
          // ja, also CursorY bleibt, aber filepos+cursorindex ndern
          scroll(1);
        }
        else  // Cursor war weiter oben
          moveCursor(0,1);
      } // END if(!filepos && !cursorY)
      e->accept();
      return;
      break;
    } // END Key_Down
    //****************************************************************
    case Qt::Key_PageDown:
    {
      if(filepos+(lines-1)*bytesPerLine >= filesize) // Sind wir am Ende?
      {
        ctimer->stop();
        deleteCursor();
        int diff = filesize-cursorIndex-1;
        cursorY += diff/bytesPerLine;
        int xadd = diff % bytesPerLine;
        cursorX += xadd;
        if(cursorX > (bytesPerLine-1))
        {
          cursorY ++;
          cursorX -= bytesPerLine;
        }
        cursorIndex = filepos + (cursorY*bytesPerLine) + cursorX;
        updateInfo();
        cursorTimer();
        ctimer->start(500);
        ;;;;; // wenn y > lines, dann neu aufbauen
      }
      else
      {
        // ja, also CursorY bleibt, aber filepos+cursorindex ndern
        filepos += (lines-1)*bytesPerLine;
        cursorIndex = filepos + (cursorY*bytesPerLine) + cursorX;
        updateInfo();
        // OK, jetzt ab der Stelle im File neu einlesen
        read();
        // und noch nen bischen blitten
        fillBuffer();
        paintEvent((QPaintEvent *)0L);
        cursorTimer();
      }
      e->accept();
      return;
      break;
    }
    //****************************************************************
    case Qt::Key_PageUp:
    {
      if((filepos-(lines-1)*bytesPerLine) > filepos) // Sind wir am Ende?
      {
        filepos = cursorY = cursorX = 0;
      }
      else
      {
        filepos -= (lines-1)*bytesPerLine;
      }

      cursorIndex = filepos + (cursorY*bytesPerLine) + cursorX;
      updateInfo();
      // OK, jetzt ab der Stelle im File neu einlesen
      read();
      // und noch nen bischen blitten
      fillBuffer();
      paintEvent((QPaintEvent *)0L);
      cursorTimer();
      e->accept();
      return;
      break;
    }
    //****************************************************************
    case Qt::Key_End:
    {
      // Schon etwas komplizierter
      uint newpos = (filesize/bytesPerLine*bytesPerLine) - (lines-1)*bytesPerLine;
      if(newpos > filesize)
        filepos = 0;
      else
        filepos = newpos;
      // Cursor auf letztes Zeichen stellen
      cursorY = (filesize-filepos)/bytesPerLine;
      cursorX = (filesize-filepos) -((filesize-filepos)/bytesPerLine*bytesPerLine)-1;
      cursorIndex = filepos + (cursorY*bytesPerLine) + cursorX;
      updateInfo();
      read();
      // und noch nen bischen blitten
      fillBuffer();
      paintEvent((QPaintEvent *)0L);
      cursorTimer();
      e->accept();
      return;
      break;
    }
    case Qt::Key_Home:
    {
      filepos = cursorX = cursorY = 0;
      cursorIndex = 0;
      updateInfo();
      read();
      // und noch nen bischen blitten
      fillBuffer();
      paintEvent((QPaintEvent *)0L);
      cursorTimer();
      e->accept();
      return;
      break;
    }
  }
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************
// OK, hier fangen wir mit Editor an...
  if(edit)
  {
    // HEX oder ASCII Eingabe
    if(TABFLAG == 0)
    {
      // HEX Input
      if(
          (e->text() >= "0" && e->text() <= "9") ||
          (e->text() >= "a" && e->text() <= "f") ||
          (e->text() >= "A" && e->text() <= "F") ||
          e->key() == Qt::Key_Enter ||
          e->key() == Qt::Key_Return
        )
      {
        char c = e->ascii();
        if(c >= '0' && c <= '9')
          c -= '0';
        else if(c >= 'A' && c <= 'F')
          c = c - 'A' + 10;
        else if(c >= 'a' && c <= 'f')
          c = c - 'a' + 10;
        // ist das Zeichen das zuerst eingegebene??
        if(!digit)
        {
          // JA!
          digit = true;
          digit1 = c;
          // zweiten Teil des Byte's retten
          digit2 = byteUnderCursor() & 0x0f;
        }
        else
        {
          // NEIN, das Zweite
          digit2 = c;
          digit = false;
        }
        undoAdd();
        setByteUnderCursor(digit1*16+digit2);
        if(!digit)
          cursorToNextPos();
      }
      else
      {
//        "Kein Digit";
      }
    }
    else
    {
      // ASCII Input
      QChar c(e->ascii());
      if(c.isPrint())
      {
        // Zuerst altes Zeichen unter Cursor retten
//        QChar c = byteUnderCursor();
        undoAdd();
        setByteUnderCursor(c);
        cursorToNextPos();
      }
    }
  }
  e->accept();

}

void hexViewEdit::undoOneItem()
{
  if(undos == 0)
    return;
  ub *temp = undoList->lastNode;

  fseek(file, temp->offset, SEEK_SET); // Adresse fr Read/Write im File positionieren
  fputc(temp->byte,file);
  fflush(file);
  updatePos(temp->offset);
  // UndoItem von Liste entfernen
  if(undos==1)
  {
    delete undoList;
    undoList = 0L;
    undos = 0;
    updateInfo();
    return;
  }
  if(undos==2)
  {
    undos = 1;
    undoList->nextNode = 0L;
    undoList->lastNode = undoList;
    delete temp;
    updateInfo();
    return;
  }

  undoList->lastNode = temp->prevNode;
  ub *newLast = temp->prevNode;
  newLast->nextNode = 0L;
  newLast->lastNode = newLast;
  undos--;
  updateInfo();
}
void hexViewEdit::undoAdd()
{
  ub *undoItem = new ub;
  ub *lastItem;
/*
struct ub{
            uint offset;
            uchar byte;
            struct ub *nextNode;
            struct ub *prevNode;
            struct ub *lastNode; // for reverse (undo is allways reverse ;) )
          };
*/
  undoItem->offset = cursorIndex;
  undoItem->byte = byteUnderCursor();
  undoItem->nextNode = 0L;
  undoItem->lastNode = undoItem; // lastNode ist nur im ersten Item relevant
  if(!undoList)
  {
    // Neue Liste = neues Item
    undoList = undoItem;
    undoItem->prevNode = 0L;
  }
  else
  {
    // Liste existiert schon, also neues Item hinten anfgen
    lastItem = undoList->lastNode;
    undoList->lastNode = undoItem;
    // lastItem ist nun vorletztes Item
    lastItem->nextNode = undoItem;
    undoItem->prevNode = lastItem;
  }

  // Nun Infos erstellen
  undos=1;
  undoItem = undoList;
  while(undoItem->nextNode != 0)
  {
    undoItem = undoItem->nextNode;
    undos += 1;
  }
}
QChar hexViewEdit::byteUnderCursor()
{
  uchar c = ' ';
  fseek(file, cursorIndex, SEEK_SET); // Adresse fr Read/Write im File positionieren
  readed = fread(&c,1, 1, file);
  return(QChar(c));
}
void hexViewEdit::setByteUnderCursor(uchar c)
{
  fseek(file, cursorIndex, SEEK_SET); // Adresse fr Read/Write im File positionieren
  fputc(c,file);
  fflush(file);
  updateCursor();
}
void hexViewEdit::deleteCursor()
{
  // Pos. des HEX Cursors
  int cx = 5 + cursorw*12 + cursorX * 3 * cursorw;
  // Pos. des ASCII Cursors
  //            adresse>:
  int cx2 = 5 + cursorw*12 + (bytesPerLine+1)*3*cursorw + cursorX*cursorw;

  bitBlt( this, cx , 7 + cursorY * fontsize, bufferPixmap,cx-5,2+cursorY*fontsize,cursorw*2,fontsize);  // Cursor ber Hexzahl
  bitBlt( this, cx2, 7 + cursorY * fontsize, bufferPixmap,cx2-5,2+cursorY*fontsize,cursorw,fontsize);   // Cursor ber Ascii
  bitBlt( this,   5, 7 + cursorY * fontsize, bufferPixmap, 0, 2+cursorY*fontsize, cursorw*9, fontsize); // Cursor ber Adresse
}
void hexViewEdit::read()
{
  fseek(file, filepos, SEEK_SET); // Adresse fr Read/Write im File positionieren
  readed = fread(filebuffer,1, buffersize, file);
}
void hexViewEdit::mousePressEvent(QMouseEvent *e)
{
  // hier muss noch rein das Maus die Cursorposition verndert!!
}
void hexViewEdit::mouseReleaseEvent(QMouseEvent *e)
{
  // hier muss noch rein das Maus die Cursorposition verndert!!
}

void hexViewEdit::resizeEvent(QResizeEvent *e)
{
  // Hier muss die gepufferte Pixmap geresized werden
  // wenn gerade geblitted wird, dann weg hier
  if(resizing)
    return;
//  debug("Breite: %d", e->size().width());
  // Anzahl der Zeichen des Bildschirms
  int w = e->size().width()-10-32;  // - 10 Pixel Rand - 32 Pixel Scrollbar
  int chars = w/cursorw;            // stimmt bis hierher
  bytesPerLine = (chars-15)/4;      // Dieser Wert gilt fr alle Berechnungen (das was vorher 16 war)

  int h = e->size().height() -10;   // jeweils 5 Pixel Rand
  // Zuerst Anzahl sichtbarer Zeilen errechnen
  lines = h / fontsize;                                           // OK
  // bei Scrollbar PageDown/Up sollen genau 'lines - 1' Zeilen weitergeblttert werden
  scrollbar->setPageStep(lines-1);
  // Wieviel Zeilen hat das File?
  int filelines = filesize/bytesPerLine;
  if(filesize % bytesPerLine != 0)
    filelines++;
  // ScrollBar Values neu berechnen
  if(filelines - lines >= 0)
    scrollbar->setMaxValue(filelines-lines);
  else
    scrollbar->setMaxValue(0);
  resizing = true;
  scrollbar->setGeometry(width()-32,0,32,height());

  // Der Scrollbar Maxvalue muss auf Seiten bezogen werden, nicht auf Zeilen...shit
  // Buffersize berechnen
  buffersize = lines * bytesPerLine;

  // filebuffer lschen und neu allokieren
  if(filebuffer)
    free(filebuffer);
  // if windowsize changed we must allocate new memory
  filebuffer = (char *)malloc(buffersize);
  // Bytes neu einlesen
  read();

  // Pixmapbuffer Gre ndern
  bufferPixmap->resize(e->size());
  fillBuffer();
  resizing = false;
  updateInfo();

}
void hexViewEdit::fillBuffer()
{
  // Fllt die BufferPixmap mit aktuellem Text

  // Buffer leeren
  bufferPixmap->fill(); // CONFURABLE
  QPainter buffer(bufferPixmap);
  // Font setzen
  buffer.setFont(*myFont);
  // Tinte auf Schwarz setzen
  buffer.setPen(black); // CONFURABLE
  // Text schreiben...
  QString s;
  // Schleife von 0 bis lines-1
  for(int i=0; i < lines; i++)
  {
    // Sind wir schon eine Zeile bers Fileende hinaus?
    if(filepos + i*bytesPerLine >= filesize)
      break;
    s = mem2String(filepos +i*bytesPerLine, filebuffer + i*bytesPerLine,bytesPerLine);
//                 Offset im Buf  MemBuffer         Anzahl Zeichen
    // Schreibe Text auf(0,y)
    buffer.drawText(0,i * fontsize+fontsize,s);

// Die 3 Zeilen fr Test drinne lassen !!
//    buffer.drawText(0,(i*2) * fontsize+fontsize,s);
//    buffer.drawText(0,14,"0123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789");
//    buffer.drawText(0,28,"          1         2         3         4         5         6         7         8         9         ");
  }
}
void hexViewEdit::paintEvent(QPaintEvent *e)
{
  bitBlt( this, 5 , 5 , bufferPixmap);
  cursorTimer();
}
QString hexViewEdit::byte2String(int hex)
{
  QString s;
  s.sprintf("%8.8X", hex);
  s = s.right(2);
  return s;
}
QString hexViewEdit::word2String(int hex)
{
  QString s;
  s.sprintf("%8.8X", hex);
  s = s.right(4);
  return s;
}
QString hexViewEdit::long2String(int hex)
{
  QString s;
  s.sprintf("%8.8X", hex);
  s = s.left(4) + ":" + s.right(4);
  return s;
}
QString hexViewEdit::mem2String(int offset, char *addr, int len)
{
  // Offset ist die absolute Adresse, wo wir uns im File befinden
  // Konvertiert <len> Bytes ab Speicheradresse <addr> in einen Hexkonformen String
  uchar *b = (uchar *)addr;


  // Wir fangen an, eine Zeile zu bauen
  QString zeile;
  // Zeile beginnt mit Hexadresse + Cursor, e.g. "0000:1ff0 > "
  zeile = long2String(offset) + " > ";
  // Hier bauen wir die Hexzahlen zusammen
  QString text;
  for(int i=0;i<len;i++)
  {
    if((uint)offset+i<filesize)
    {
      // ist noch nen Byte im Buffer, so eine Hexzahl dazu
      zeile = zeile + byte2String(b[i]) + " ";
      // parallel dazu die Ascii Codes adden (Ende jeder Zeile)
      // Zeichen filtern....unbedingt bentigt fr nicht lesbare Zeichen
      if(QChar(b[i]).isPrint())
        text = text + QChar(b[i]);
      else
        text += "_";  // CONFIGURABLE Chra fr nicht lesbare Zeichen
    }
    else
    {
      // ansonsten nen Leerfeld
      zeile = zeile + "   ";
      text += " ";
    }
  }
  // Abschluss der Hexcodes
  zeile += " : ";
  zeile += text;
  return zeile;
}
void hexViewEdit::cursorTimer()
{  // Bitte Blitten Cursor
  setFocus();
  QPainter paint(this);
  int cx  = 5 + cursorw*12 + cursorX * 3 *cursorw;
  int cx2 = 5 + cursorw*12 + (bytesPerLine+1)*3*cursorw + cursorX*cursorw;

  // Farbe auffllen
  if(edit)
  {
    if(TABFLAG == 0)
    {
      // HEX Cursor
      if(blinkflag)
      {
        blinkflag = false;
        paint.fillRect(cx, 7 + cursorY * fontsize, cursorw*2, fontsize,  red);
      }
      else
      {
        blinkflag = true;
        paint.fillRect(cx, 7 + cursorY * fontsize, cursorw*2, fontsize,  cyan);
      }
      // ASCII Cursor
      paint.fillRect(cx2, 7 + cursorY * fontsize, cursorw, fontsize,  CURSORCOLOR);
    }
    else
    {
      // HEX Cursor
      paint.fillRect(cx, 7 + cursorY * fontsize, cursorw*2, fontsize,  CURSORCOLOR);
      // ASCII Cursor
      if(blinkflag)
      {
        blinkflag = false;
        paint.fillRect(cx2, 7 + cursorY * fontsize, cursorw, fontsize,  red);
      }
      else
      {
        blinkflag = true;
        paint.fillRect(cx2, 7 + cursorY * fontsize, cursorw, fontsize,  cyan);
      }
    }
  }
  else
  {
    // HEX Cursor
    paint.fillRect(cx, 7 + cursorY * fontsize, cursorw*2, fontsize,  CURSORCOLOR);
    // ASCII Cursor
    paint.fillRect(cx2, 7 + cursorY * fontsize, cursorw, fontsize,  CURSORCOLOR);
  }
  // Cursor ber gesamte Adresse
  paint.fillRect(5, 7 + cursorY * fontsize, cursorw*9, fontsize,  CURSORCOLOR);


  // jetzt den Bereich des Cursorbereiches aus der Bufferpixmap drberblitten
  bitBlt( this, cx , 7 + cursorY * fontsize, bufferPixmap, (cx-5), 2+cursorY*fontsize, cursorw*2, fontsize, Qt::AndROP );
  bitBlt( this, cx2 ,7 + cursorY * fontsize, bufferPixmap, (cx2-5),2+cursorY*fontsize, cursorw  , fontsize, Qt::AndROP );
  bitBlt( this, 5,   7 + cursorY * fontsize, bufferPixmap, 0,      2+cursorY*fontsize, cursorw*9, fontsize, Qt::AndROP );
}
void  hexViewEdit::updateInfo()
{
  if(bytesPerLine >1000 || bytesPerLine<0)
    return;
  QString s1,s2;

  uchar *b = (uchar *)filebuffer + cursorY*bytesPerLine + cursorX;
  if(b[0]<10)
    s2.sprintf("Char: (hex)%2.2X   (dec):  %d   Undo Entrys: %d",b[0],b[0],undos);
  else if(b[0]<100)
    s2.sprintf("Char: (hex)%2.2X   (dec): %d   Undo Entrys: %d",b[0],b[0],undos);
  else
    s2.sprintf("Char: (hex)%2.2X   (dec):%d   Undo Entrys: %d",b[0],b[0],undos);
  emit info1changed(s2);


  if(cursorIndex < 0x10000)
  {
    s1.sprintf("Filepos: 0000:%4.4X / ",cursorIndex);
  }
  else
  {
    uint t = cursorIndex / 0x10000;
    s1.sprintf("Filepos: %4.4X:%4.4X / ",t,cursorIndex-t*0x10000);
  }

  if(filesize < 0x10000)
  {
    s2.sprintf("0000:%4.4X   ",filesize);
  }
  else
  {
    uint t = filesize / 0x10000;
    s2.sprintf("%4.4X:%4.4X   ",t,filesize-t*0x10000);
  }
  s1 += s2;
  s2.sprintf("%d / %d", cursorIndex, filesize);
  s1 += s2;
  emit info2changed(s1);
}
void  hexViewEdit::scrollbarChanged(int p)
{
  filepos = p*bytesPerLine;
  cursorIndex = filepos;
  updateInfo();
  read();
  // und noch nen bischen blitten
  fillBuffer();
  paintEvent((QPaintEvent *)0L);
  cursorTimer();
}
void  hexViewEdit::updateCursor()
{
  // Funktion updated den Text unter dem Cursor (genderter Inhalt)
  ctimer->stop();
  deleteCursor();
  read();
  fillBuffer();
  int cx = 5 + cursorw*12 + cursorX * 3 * cursorw;
  int cx2 = 5 + cursorw*12 + (bytesPerLine+1)*3*cursorw + cursorX*cursorw;
  bitBlt( this, cx , 7 + cursorY * fontsize, bufferPixmap,cx-5,2+cursorY*fontsize,cursorw*2,fontsize);  // Cursor ber Hexzahl
  bitBlt( this, cx2, 7 + cursorY * fontsize, bufferPixmap,cx2-5,2+cursorY*fontsize,cursorw,fontsize);   // Cursor ber Ascii
  cursorTimer();
  ctimer->start(500);
  updateInfo();
}
void  hexViewEdit::updatePos(uint offset)
{
  uint max = filepos + lines*bytesPerLine; //
  int cX = 0;
  int cY = 0;
  // Funktion updated eine andere Position, wenn sie innerhalb des Fensters liegt
  if(offset < filepos || offset >= max)
    return;
  ctimer->stop();
  deleteCursor();
  read();
  fillBuffer();

  // temp Cursor berechnen
/*
        int diff = filesize-cursorIndex-1;
        cursorY += diff/16;
        int xadd = diff % 16;
*/
  int diff = offset-filepos;
  cY = diff/bytesPerLine;
  cX = diff % bytesPerLine;

  int cx = 5 + cursorw*12 + cX * 3 * cursorw;
  int cx2 = 5 + cursorw*12 + (bytesPerLine+1)*3*cursorw + cX*cursorw;
  bitBlt( this, cx , 7 + cY * fontsize, bufferPixmap,cx-5 ,2+cY*fontsize,cursorw*2,fontsize);  // Cursor ber Hexzahl
  bitBlt( this, cx2, 7 + cY * fontsize, bufferPixmap,cx2-5,2+cY*fontsize,cursorw  ,fontsize);   // Cursor ber Ascii
  cursorTimer();
  ctimer->start(500);

}
