/***************************************************************************
                          kcdrivebuttonbar.cpp  -  description
                             -------------------
    begin                : Wed Dec 12 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#include "kcdrivebuttonbar.h"
#include <kcfstab.h>
#include <qpixmap.h>
//******************************************************************************************************
//
// Was soll der Button?
//  per Timer immerwieder nachschauen, ob der Mountpoint eingehangen ist
//  bei Click Device erst mounten falls ntig
//
//
//
#include "db_cd.xpm"

//#include "db_disk.xpm"
#include "db_ftp.xpm"
#include "db_hd.xpm"
#include "db_net.xpm"

class klasse;
static char * db_disk_xpm[] = {"13 13 6 1"," 	c None",".	c #0000FF","+	c #000000","@	c #C0C0C0","#	c #FFFFFF",
                               "$	c #FF0000","..+.+@@@@..++",".@+.+@@.@.@.+",".@+.+@@.@.@.+","..+.+@@.@...+"
                               ,"..+++@@@@...+","............+","..++++++++..+",".+########+.+",".+$$$$$$$$+.+",
                               ".+########+.+",".+########+++",".+$$$$$$$$+@+","+++++++++++++"};
//static char * folder_unreadable_xpm[] = {
//  "24 13 57 1"," 	c None",".	c #808080","+	c #F90429","@	c #B54959","#	c #C0C0C0","$	c #FFFF00",
//  "%	c #F00C2E","&	c #F92D22","*	c #C1BBBC","=	c #B74758","-	c #EF0D2F",";	c #F5072B",">	c #F80429",
//  ",	c #FA4762","'	c #FB6279",")	c #FFFFFF","!	c #FB7589","~	c #F90B2F","{	c #F90F33","]	c #FA3653",
//  "^	c #FB6E83","/	c #FDADB9","(	c #000000","_	c #FEDC05",":	c #F60D30","<	c #F90428","[	c #F31637",
//  "}	c #FDCF07","|	c #FEE604","1	c #F8062B","2	c #FB581B","3	c #F21839","4	c #F90628","5	c #CF8994",
//  "6	c #FA2E22","7	c #F92922","8	c #FEF9F9","9	c #F31436","0	c #D96D7D","a	c #FB6D17","b	c #FDAD0D",
//  "c	c #F92848","d	c #D67684","e	c #F91226","f	c #F50F31","g	c #CE2F47","h	c #DC6375","i	c #E5455D",
//  "j	c #F7052A","k	c #F92C4B","l	c #F0203F","m	c #CB98A0","n	c #A55965","o	c #857A7B","p	c #F6062B",
//  "q	c #E61636","r	c #51010D","       .....            ","     +@#$#$#.           ","     %+&*$#$#=-;>+++    ",
//  "     .,++')!~+{]^/.(    ","     .)_:+><[}#$#$.(    ","     .)#|1<>2#$#$#.(    ","     .)$3456+7#$#$.(    ",
//  "     .89<0$#a+b#$#.(    ","     .c<d$#$#ef$#$.(    ","     g+d$#$#$h+i$#.(    ","     jk$#$#$#$l<m$.(    ",
//  "     no........pq..(    ","      (((((((((rr(((    "};

kcDriveButton::kcDriveButton(QWidget *parent, const char *name ) : kcSimpleButton(parent,name)
{
  mounting = false;
  pmCD = new QPixmap((const char **)db_cd_xpm);
  pmDISK = new QPixmap((const char **)db_disk_xpm);
  pmFTP = new QPixmap((const char **)db_ftp_xpm);
  pmHD = new QPixmap((const char **)db_hd_xpm);
  pmNET = new QPixmap((const char **)db_net_xpm);
  mounted = false;
  device =  mountPoint =  fileSystem = "";
  setMinimumSize(32,22);
  setMaximumSize(32,22);
  show();
  QFileInfo fi("/etc/mtab");
  mtabTime = fi.lastModified();
  startTimer(1000); // alle 5 Sekunden den Status der LW's kontrollieren
}
kcDriveButton::~kcDriveButton(){
}
void kcDriveButton::paintEvent(QPaintEvent *e)
{
  QPixmap *temp = pmHD;

  if(fileSystem == "nfs")
    temp = pmNET;
  else if(mountPoint.find("floppy")!= -1)
    temp = pmDISK;
  else if(mountPoint.find("cdrom")!= -1)
    temp = pmCD;
  kcSimpleButton::paintEvent(e);
  // Hier Male Male machen
  QPainter p(this);
  int x = 30-temp->width();
  x = x/2;
  int y = 22-temp->height();
  y = y/2;
  p.drawPixmap(x+4,y,*temp);

  p.setPen(green);
  if(!mounted)
    p.setPen(red);
  p.drawLine(3,3,3,height()-3);
  p.drawLine(4,3,4,height()-3);
}
void kcDriveButton::setDevice(const QString &t)
{
  device = t;
}
void kcDriveButton::setMountPoint(const QString &t)
{
  mountPoint = t;
  mounted = mountState(mountPoint);
  update();
}
void kcDriveButton::setFS(const QString &t)
{
  fileSystem = t;
  QString tip("Device: " + device + "\nMountpoint: " + mountPoint + "\nFilesystem: " + fileSystem);
  tip += "\nLeft Mouse mount\nRight Mouse umount";
  QToolTip::add(this,tip);
}
void kcDriveButton::timerEvent(QTimerEvent *e)
{
  QFileInfo fi("/etc/mtab");
  QDateTime mtabTime2 = fi.lastModified();
  if(mtabTime2 != mtabTime)
  {
    mtabTime = mtabTime2;
    mounted = mountState(mountPoint);
    update();
  }
}
bool kcDriveButton::mountState(QString &mp)
{
  QFile mtab("/etc/mtab");
  if ( mtab.open(IO_ReadOnly) )
  {   // file opened successfully
      QTextStream t( &mtab );
      QString s;
      while ( !t.eof() )
      {   // until end of file...
          s = t.readLine();
          if(s.find(mp)!= -1)
          {
            return true;
          }
      }
      mtab.close();
  }
  return false;
}

void kcDriveButton::mouseReleaseEvent(QMouseEvent *e)
{
  QString command("mount");
  kcSimpleButton::mouseReleaseEvent(e);
  if(!mouseover)
    return;

  if(e->button() == RightButton)
    command = "umount";
  proc = new QProcess( this );
  connect(proc, SIGNAL(processExited()), SLOT(commandReady()));

  connect(proc, SIGNAL(readyReadStdout()), SLOT(readyReadStdout()));
  connect(proc, SIGNAL(readyReadStderr()), SLOT(readyReadStderr()));

  proc->addArgument(command);
  proc->addArgument(mountPoint);
  mounting = true;
  proc->start();
  while(mounting)
  {
    qApp->processEvents();
  }

}
void kcDriveButton::commandReady()
{
  if(!proc->exitStatus())
    emit deviceChanged(mountPoint);
  mounting = false;
}
void kcDriveButton::readyReadStderr()
{
  QString s = proc->readLineStderr();
  QMessageBox::warning( this, "System Message",s );
}
void kcDriveButton::readyReadStdout()
{
  QString s = proc->readLineStdout();
}
//******************************************************************************************************
kcDriveButtonBar::kcDriveButtonBar(QWidget *parent, const char *name ) : QWidget(parent,name)
{
  setMinimumSize(32,25);
  setMaximumSize(32000,25);
  show();
  buttonCount = 0;

  kcfstab fstab;
  QString line;

  while(fstab.getfsent())
  {
    line = fstab.FS();
    if(line != "swap" && line != "proc")
    {
      buttons[buttonCount] = new kcDriveButton(this);
      buttons[buttonCount]->setDevice(fstab.Device());
      buttons[buttonCount]->setMountPoint(fstab.Mountpoint());
      buttons[buttonCount]->setFS(fstab.FS());
      buttons[buttonCount]->move(buttonCount*32,0);
      connect(buttons[buttonCount], SIGNAL(deviceChanged(QString)), SLOT(deviceChanged(QString)));
      buttonCount++;
    }
  }
}
kcDriveButtonBar::~kcDriveButtonBar()
{
}
void kcDriveButtonBar::deviceChanged(QString s)
{
  emit driveChanged(s);
}
