/***************************************************************************
                          kcdrivebuttonbar.h  -  description
                             -------------------
    begin                : Wed Dec 12 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#ifndef KCDRIVEBUTTONBAR_H
#define KCDRIVEBUTTONBAR_H

#include <qwidget.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qfile.h>
#include <qapp.h>
#include <qtooltip.h>
#include <qfileinfo.h>
#include <qprocess.h>
/**
  *@author Christian Fricke & Ren Mrten
  */
#include "kcsimplebutton.h"

class kcDriveButton : public kcSimpleButton  {
   Q_OBJECT
public:

	kcDriveButton(QWidget *parent=0, const char *name=0);
	~kcDriveButton();
  void setDevice(const QString &);
  void setMountPoint(const QString &);
  void setFS(const QString &);
private:
  QProcess    *proc;
  QPixmap     *pmCD, *pmDISK, *pmFTP, *pmHD, *pmNET;
  QString     device, mountPoint, fileSystem;
  bool        mounted;
  QDateTime   mtabTime;
  bool        mountState(QString &mp);
  bool        mounting;
private slots:
  void        paintEvent(QPaintEvent *e);
  void        timerEvent(QTimerEvent *e);
  void        mouseReleaseEvent(QMouseEvent *e);
  void        commandReady();
  void        readyReadStderr();
  void        readyReadStdout();
signals:
  void        deviceChanged(QString);
};



class kcDriveButtonBar : public QWidget  {
   Q_OBJECT
public:
	kcDriveButtonBar(QWidget *parent=0, const char *name=0);
	~kcDriveButtonBar();
private:
  int buttonCount;
  kcDriveButton *buttons[20];
signals:
  void driveChanged(QString);
private slots:
  void deviceChanged(QString);
};

#endif
