/****************************************************************************
** $Id: kcmailus.cpp,v 1.10 2002/04/21 16:51:01 cfricke Exp $
**
** Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#include "kcmailus.h"
#include "kcsmtp.h"

#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>

mailComposer::mailComposer( QWidget *parent )
    : QWidget( parent )
{
    QGridLayout * l = new QGridLayout( this, 3, 5, 6 );

    l->addWidget( new QLabel( tr( "From:" ), this ), 0, 0 );
    from = new QLineEdit( this );
    l->addWidget( from, 0, 1 );

    l->addWidget( new QLabel( tr( "To:" ), this ), 1, 0 );
    to = new QLineEdit( this );
    l->addWidget( to, 1, 1 );

    l->addWidget( new QLabel( tr( "Subject:" ), this ), 3, 0 );
    subject = new QLineEdit( this );
    l->addWidget( subject, 3, 1 );

    message = new QMultiLineEdit( this );
    l->addMultiCellWidget( message, 4, 4, 0, 2 );

    send = new QPushButton(tr("&Send"), this);
    l->addWidget( send, 5, 0 );
    connect( send, SIGNAL( clicked() ), this, SLOT( sendMessage() ) );

    sendStatus = new QLabel( this );
    l->addWidget( sendStatus, 5, 1 );

    quit = new QPushButton(tr("&Quit"), this);
    l->addWidget( quit, 5, 2 );
    connect( quit, SIGNAL( clicked() ), this, SLOT( slotClose() ) );
}

mailComposer::mailComposer(QFileInfo file, QWidget *parent )
    : QWidget( parent )
{
    finfo = file;

    QGridLayout * l = new QGridLayout( this, 3, 5, 6 );

    l->addWidget( new QLabel( tr( "From:" ), this ), 0, 0 );
    from = new QLineEdit( this );
    l->addWidget( from, 0, 1 );

    l->addWidget( new QLabel( tr( "To:" ), this ), 1, 0 );
    to = new QLineEdit( this );
    l->addWidget( to, 1, 1 );

    l->addWidget( new QLabel( tr( "Subject:" ), this ), 3, 0 );
    subject = new QLineEdit( this );
    l->addWidget( subject, 3, 1 );
    subject->setText( "File: "+ finfo.fileName() + " sent by KCommander3");
    subject->setEnabled(false);

    message = new QMultiLineEdit( this );
    l->addMultiCellWidget( message, 4, 4, 0, 2 );
    message->setText("Attachement : "+ finfo.fileName());
    message->setEnabled(false);

    send = new QPushButton(tr("&Send"), this);
    l->addWidget( send, 5, 0 );
    connect( send, SIGNAL( clicked() ), this, SLOT( sendFileMessage() ) );

    sendStatus = new QLabel( this );
    l->addWidget( sendStatus, 5, 1 );

    quit = new QPushButton(tr("&Quit"), this);
    l->addWidget( quit, 5, 2 );
    connect( quit, SIGNAL( clicked() ), this, SLOT( slotClose() ) );
}


void mailComposer::sendMessage()
{
    send->setEnabled( FALSE );
    sendStatus->setText( tr( "Looking up mail servers" ) );
    kcSmtp *smtp = new kcSmtp( from->text(), to->text(), subject->text(), message->text() );
    connect( smtp, SIGNAL(destroyed()), this, SLOT(enableSend()) );
    connect( smtp, SIGNAL(status(const QString &)), this, SLOT(slotReadySent(const QString &)) );
}

void mailComposer::sendFileMessage()
{
    send->setEnabled( FALSE );
    sendStatus->setText( tr( "Looking up mail servers" ) );
    kcSmtp *smtp = new kcSmtp( from->text(), to->text(), finfo.filePath() );
    connect( smtp, SIGNAL(destroyed()), this, SLOT(enableSend()) );
    connect( smtp, SIGNAL(status(const QString &)), this, SLOT(slotReadySent(const QString &)) );
}


void mailComposer::enableSend()
{
    send->setEnabled( TRUE );
}

void mailComposer::slotReadySent(const QString &text)
{
  sendStatus->setText(text);
  if(text == "Message sent") close();
}
