/***************************************************************************
                          kcommander3.h  -  description
                             -------------------
    begin                : Die Dez 11 15:29:21 CET 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#ifndef KCOMMANDER3_H
#define KCOMMANDER3_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qsettings.h>
#include <qvariant.h>
#include <qsplitter.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qworkspace.h>

// eigene Includes

#include "kcimageviewer.h"
#include "kcommander3view.h"
#include "bookmarkcombobox.h"
#include "kcdrivebuttonbar.h"
#include "kcfiledialog.h"
#include "kctextviewer.h"
#include "dlgcopy.h"
#include "dlgAdressbook.h"

#include "hexviewedit.h"
#include "dlgoptions.h"
#include "kcmailus.h"

/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class KCommander3View is
  * created which creates your view.
  */
class KCommander3App : public QMainWindow
{
  Q_OBJECT
  
  public:
    /** construtor */
    KCommander3App();
    /** destructor */
    ~KCommander3App();
    /** initializes all QActions of the application */
    void initActions();
//    void initMenuBar();
    void initToolBar();
    void initView();

    /**Ich weiss nicht ob wir es public brauchen aber mal sehen*/
    kcommander3view   *view;
    kcFileDialog      *leftDialog;
    kcFileDialog      *rightDialog;

    void SetCentralWidget(QWidget *);

  private:
    bookmarkComboBox  *pg;
    /** file_menu contains all items of the menubar entry "File" */
    QPopupMenu        *fileMenu;
    QPopupMenu        *selectMenu;
    QPopupMenu        *optionsMenu;
    QPopupMenu        *helpMenu;
    /** the main toolbar */
    QToolBar          *fileToolbar;
    /** actions for the application initialized in initActions() and used to en/disable them
      * according to your needs during the program */
    QAction           *rereadSource;
    QAction           *changeLists;
    QAction           *helpAboutApp;
    QAction           *mailUs;
    QAction           *testEntry;

    void              savePrefs();

    QTimer            *startTimer; // i know, its ugly
    hexViewEdit       *hexEdit;
//    QWorkspace  *ws;

private slots:
    void              startReading();
    void              slotrereadSource();
    void              slotChangeLists();
    void              slotMailUs();
    void              slotHelpAbout();
    void              closeEvent(QCloseEvent *e);
    void              testSlot();
    void              slotNumPlus();
    void              slotNumMinus();
    void              slotCTRLNumPlus();
    void              slotCTRLNumMinus();

    void              slotOptions();
    void              slotAdrBook();
    void              slotInvertSelection();
    void              slotToggleView();
    void              slotFileProperties();
    void              slotRereadSource();
    void              slotFileArchivate();

    void              slotSendFileAsMail();
protected:
};
#endif 

