/***************************************************************************
                          kcsimplebutton.h  -  description
                             -------------------
    begin                : Tue Dec 11 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#ifndef KCSIMPLEBUTTON_H
#define KCSIMPLEBUTTON_H

#include <qwidget.h>
#include <qbutton.h>
#include <qpushbutton.h>
#include <qstyle.h>
#include <qpopupmenu.h>
#include <qtimer.h>

/**
  *@author Christian Fricke & Ren Mrten
  */

class kcSimpleButton : public QButton  {
   Q_OBJECT
public: 
  kcSimpleButton(QPopupMenu *p=0, QWidget *parent=0, const char *name=0 );
	kcSimpleButton( QWidget *parent=0, const char *name=0);
	~kcSimpleButton();
	void        setText(QString );
	void        setActiveFlag(bool flag);
public slots:
  void        paintEvent(QPaintEvent *e);
  void        mouseReleaseEvent(QMouseEvent *e);
  void        mousePressEvent(QMouseEvent *e);
  void        enterEvent(QEvent *e);
  void        leaveEvent(QEvent *e);
  void        popupActivated(int);
private slots:
  void        startPopup();
public:
  bool        mouseover;
  bool        mousepressed;
  QString     text;
private:
  QPoint      pos;
  bool        isActive;           // fr den Pathbutten gedacht !!
  QTimer      *popupTimer;
  // entweder per Constructor bergeben,
  QPopupMenu  *popup;
  // oder
public:
  void        setPopupMenu(QString s1,QString s2=0,QString s3=0,QString s4=0,QString s5=0,QString s6=0,QString s7=0,QString s8=0,QString s9=0,QString s10=0,QString s11=0);
signals:
  void        popupSelected(int);

};

#endif
