/***************************************************************************
                          kcview.h  -  description
                             -------------------
    begin                : Sun Feb 10 2002
    copyright            : (C) 2002 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#ifndef KCVIEW_H
#define KCVIEW_H

#include <qstring.h>
#include <qobject.h>
#include <qevent.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qframe.h>
#include <qwidget.h>
#include <qdialog.h>
#include <qsettings.h>

#include "kcsimplebutton.h"
#include "kcfileiconprovider.h"

/**
  *@author Christian Fricke & Ren Mrten
  */

class dlgSelect : public QDialog
{
    Q_OBJECT

public:
    dlgSelect( QWidget* parent = 0, const char* name = 0);
    ~dlgSelect();
    QString resultString();
private:
    QLineEdit  *le;
    kcSimpleButton  *b1, *b2;
    QCheckBox *CS;
    QFrame *Line;

private slots:
    void keyReleaseEvent(QKeyEvent *);
    void returnPressed();
    void okClicked();
    void cancelClicked();

};

class kcView {
public:
	kcView();
	virtual ~kcView();

  kcFileIconProvider *fip;
  bool  itemItalic,itemBold, recolor;
	
	virtual QString dirname(){return "Virtual";};
	virtual QString realDirname(){return "Virtual";};
   virtual QString getExpression(){return "Virtual";};
	virtual void       sendKey(QKeyEvent *){};
   virtual void       setSelection(QString exp, bool set){};

  /** If the user had changed the settings, using optionsdialog, we have to react to.
  * Function is called by kcommander3view.cpp
  */
   virtual void settingsChanged(){};

	virtual void reRead(){};
	QString getType();
};

#endif
